part of fields.view;

class FieldView extends DivElement {  
  
  static const TAG = 'field-view';
  
  // TODO: https://code.google.com/p/dart/issues/detail?id=174
  static final Set<Field> _emptyFieldSet = new Set<Field>();
  
  final FieldSetView _children = new FieldSetView();  
  ToggleButton _toggle;
  
  Field _field;
  Field get field => _field;
  
  FieldEditor _editor;  
  bool get _isExpanded => _toggle.isDown;
  
  factory FieldView(Field field) {    
    final FieldView fv = new Element.tag('div', TAG);
    fv._initialize(field);
    return fv;
  }
  
  FieldView.created() : super.created() {}
  
  void _initialize(Field field) {
    _field = field;
    _editor = new FieldEditor.forField(_field);
    children(this, () {
      span(() {
        _toggle = toggleButton(() {
          span()..innerHtml = '&#9655;'..classes = ['up'];
          span()..innerHtml = '&#9698;'..classes = ['down'];
        })
        ..classes.add('expander')
        ..onToggle.listen((_) => refresh());      
        append(_editor.element)..style.flexGrow = '1';
      })
      ..classes.add('editorbox');
      append(_children);
    });
    field.onValueChange.listen((_) => refresh());
    _refresh();
  }
  
  void refresh() {
    _refresh();
    if (_isExpanded) {
      _children.refresh(_field.children);
    } else {
      _children.refresh(_emptyFieldSet);
    }    
  }
  
  void _refresh() {
    _toggle.hidden = _field.children.isEmpty;
    _children.hidden = !_isExpanded || _field.children.isEmpty;    
    _editor.refreshElement();
  }
}
